;;;-*-Mode: Lisp; Package: MODALYS -*-;;;----------------------------------------------------------------------;;; Modalys, example 3.;;; Simple reed/tube instrument, with a single hole near the end.;;; The hole is initially open, then it's closed, then it's opened again.;;; ;;; Please note that this example uses the 'hole connection, which is being;;; deprecated. Please consult the standard example 3 to see how to make ;;; holes on a modalys object.;;;----------------------------------------------------------------------(new);;;;;; make objects;;;(defvar my-tube)(setq my-tube      (set-pitch (make-object 'closed-open-tube                              (modes 40)                              (radius0 .01)    ;close-end                              (radius1 .01))   ;open-end                 'length 80.0))(defvar my-reed)(setq my-reed (make-object 'bi-two-mass                            (small-mass   .000002)                           (large-mass   .000002)                           ;;                           ;;  the stiffness was 2000 and now is 200                           ;;  the frequency of oscillation of the reed                             ;;  is given by the formula                           ;;                           ;;                 --                           ;;        1  \    / k                           ;;       ---  \  /  -                           ;;       2    \/   m                             ;;                             ;;   typical reed frequencies are above 1500 Hz                           ;;                           ;;  in our case, we have                           ;;                           ;;  (/ (sqrt (/ 200 .000002)) (* 2 pi))                           ;;                           ;;  which is 1591.55                                                      (stiffness0      200)                           (stiffness1      200)                           (const-loss0      60)                           (const-loss1      60)                           (freq-loss0       260)                           (freq-loss1       260)));;;;;; make reed-tube interaction;;;(defvar breath-env1)(setq breath-env1 (make-controller 'envelope 1                                   (list  (list 0.00   70)                                          (list 0.10   70)                                          (list 0.30   70)                                          (list 0.40    0)                                          (list 0.50    0)                                          (list 0.60   75)                                          (list 0.80   75)                                          (list 0.90    0)                                          (list 1.00    0)                                          (list 1.10   75)                                          (list 1.30   75)                                          (list 1.40    0)                                          (list 1.55   10)                                          (list 1.60  100)                                          (list 1.80  100)                                          (list 1.90    0)                                          (list 2.00    0)                                          (list 2.10   70)                                          (list 2.30   70)                                          (list 2.40    0)                                          (list 2.50    0)                                          (list 2.60   70)                                          (list 2.80   70)                                          (list 2.90    0)                                          (list 3.00    0)                                          (list 3.10   70)                                          (list 3.30   70))))(defvar breath-env2)(setq breath-env2 (make-controller 'envelope 1                                   (list (list 0.00   70)                                         (list 0.10   70)                                         (list 0.30   70)                                         (list 0.60   75)                                         (list 0.80   75)                                         (list 1.00  100)                                         (list 1.30  100)                                         (list 1.60  120)                                         (list 2.00  120)                                         (list 2.10  100)                                         (list 2.50  100)                                         (list 2.60   75)                                         (list 3.00   75)                                         (list 3.10   70)                                         (list 3.50   70)                                         (list 4.25    0))))(defvar breath-env3)(setq breath-env3 (make-controller 'envelope 1                                   (list (list 0.00   70)                                         (list 0.20   70)                                         (list 0.45    0)                                         (list 0.55    0)                                         (list 0.60   70)                                         (list 0.75   70)                                         (list 0.95    0)                                         (list 1.05    0)                                         (list 1.10  100)                                         (list 1.25  100)                                         (list 1.45    0)                                         (list 1.55   10)                                         (list 1.60  120)                                         (list 1.75  120)                                         (list 1.95    0)                                         (list 2.05    0)                                         (list 2.10  100)                                         (list 2.25  100)                                         (list 2.45    0)                                         (list 2.55    0)                                         (list 2.60   75)                                         (list 2.75   75)                                         (list 2.95    0)                                         (list 3.05    0)                                         (list 3.10   70)                                         (list 3.25   70)                                         (list 3.45    0))))(defvar my-tube-top)(setq my-tube-top (make-access my-tube (const 0) 'long))(defvar my-reed-tip)(setq my-reed-tip (make-access my-reed (const 1) 'trans0))(make-connection 'reed my-tube-top my-reed-tip 0.001                 ;;                   ;; the pressures that were needed to blow in the                 ;; previous Modalys were unrealistically low.                 ;; Please adjust your envelopes to be in the                 ;; 0 - 2000 Pa  range                 ;;                  (make-controller 'arithmetic 1 '* (list (const 6) breath-env2))                 (const 0.000276));;;;;; make position interaction to hold base of reed in place;;;(defvar my-reed-bse)(setq my-reed-bse (make-access my-reed (const 0) 'trans0))(make-connection 'position my-reed-bse (const 0));;;;;; make the holes;;;;;; initial hole radius 0 mm:(defvar hole-radius1)(setq hole-radius1 (make-controller 'dynamic 1 -1 (list .0)))(defvar hole-radius2)(setq hole-radius2 (make-controller 'dynamic 1 -1 (list .0)))(defvar hole-radius3)(setq hole-radius3 (make-controller 'dynamic 1 -1 (list .0)))(defvar my-tube-hle1)(setq my-tube-hle1 (make-access my-tube (const 0.7937) 'long))(make-connection 'hole my-tube-hle1 hole-radius1 (const 0.))(defvar my-tube-hle2)(setq my-tube-hle2 (make-access my-tube (const .6674) 'long))(make-connection 'hole my-tube-hle2 hole-radius2 (const 0.))(defvar my-tube-hle3)(setq my-tube-hle3 (make-access my-tube (const .5) 'long))(make-connection 'hole my-tube-hle3 hole-radius3 (const 0.));;;;;; make output;;;(defvar my-tube-out)(setq my-tube-out (make-access my-tube (const .25) 'long))(make-point-output my-tube-out);;;;;; run the synthesis and play the sound;;;(run 0.5)(set-breakpoint hole-radius1 (list 0.05 0.01))  ;; open first hole in 0.05 sec(run 0.5)(set-breakpoint hole-radius2 (list 0.05 0.01))  ;; open the second hole (run 0.5)(set-breakpoint hole-radius3 (list 0.05 0.01))  ;; open the third hole(run .5)(set-breakpoint hole-radius3 (list 0.05 0.0))  ;; close the third hole(run .5)(set-breakpoint hole-radius2 (list 0.05 0.0))  ;; close the second hole(run .5)(set-breakpoint hole-radius1 (list 0.05 0.0))  ;; close the first hole(run 1.5)(play)